controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionCrud() {
        return $this->render("gestion");
    }
    
    public function actionConsulta1a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("edad")->distinct(),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=> "Consulta 1 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas (sin repetidos)",
            "sql"=>"select distinct edad from ciclista",
        ]);
        
        
    }
    public function actionConsulta2a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("edad")
                ->distinct()
                ->where("nomequipo='Artiach'"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=> "Consulta 2 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas de Artiach",
            "sql"=>"select distinct edad from ciclista where nomequipo='Artiach'",
        ]);
        
        
    }
     public function actionConsulta3a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("edad")
                ->distinct()
                ->where("nomequipo='Artiach' or nomequipo='Amore Vita'"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=> "Consulta 3 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas de Artiach o de Amore Vita",
            "sql"=>"select distinct edad from ciclista where nomequipo='Artiach' or nomequipo='Amore Vita'",
        ]);
        
        
    }
    
    
    public function actionConsulta1() {
        // mediante DAO
        $numero=Yii::$app
                ->db
                ->createCommand('select count(distinct edad) from ciclista')
                ->queryScalar();
        
        $dataProvider=new SqlDataProvider([
            'sql'=>'select distinct edad from ciclista',
            'totalCount'=>$numero,
             'pagination'=>[
                'pageSize'=>5,
            ]
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=> "Consulta 1 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas (sin repetidos)",
            "sql"=>"select distinct edad from ciclista",
        ]);
        
    }
        
    public function actionConsulta2() {
        // mediante DAO
         $numero=Yii::$app
                ->db
                ->createCommand('select count(distinct edad) from ciclista where nomequipo="Artiach"')
                ->queryScalar();
         
        $dataProvider=new SqlDataProvider([
            'sql'=>'select distinct edad from ciclista where nomequipo="Artiach"',
            'totalCount'=>$numero,
             'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=> "Consulta 2 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas de Artiach",
            "sql"=>"select distinct edad from ciclista where nomequipo='Artiach'",
        ]);
        
    }
    
    public function actionConsulta3 () {
        // mediante DAO
         $numero=Yii::$app
                ->db
                ->createCommand('select count(distinct edad) from ciclista where nomequipo="Artiach" or nomequipo="Amore Vita"')
                ->queryScalar();
         
         $dataProvider=new SqlDataProvider([
            'sql'=>'select distinct edad from ciclista where nomequipo="Artiach" or nomequipo="Amore Vita"',
            'totalCount'=>$numero,
             'pagination'=>[
                'pageSize'=>5,
            ]
        
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=> "Consulta 3 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas de Artiach o de Amore Vita",
            "sql"=>"select distinct edad from ciclista where nomequipo='Artiach' or nomequipo='Amore Vita'",
        ]);
        
        
    }
    
    public function actionConsulta4 () {
        // mediante DAO
         $numero=Yii::$app
                ->db
                ->createCommand('select count(dorsal) from ciclista where edad<25 or edad>30')
                ->queryScalar();
         
         $dataProvider=new SqlDataProvider([
            'sql'=>'select dorsal from ciclista where edad<25 or edad>30',
            'totalCount'=>$numero,
             'pagination'=>[
                'pageSize'=>5,
            ]
        
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 4 con DAO",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
            "sql"=>"select count(dorsal) from ciclista where edad<25 or edad>30",
        ]);
        
        
    }
    
     public function actionConsulta4a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("dorsal")
                ->distinct()
                ->where("edad<25 or edad>30"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 4 con Active Record",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30",
            "sql"=>"select count(dorsal) from ciclista where edad<25 or edad>30",
        ]);
        
        
    }
    public function actionConsulta5 () {
        // mediante DAO
         $numero=Yii::$app
                ->db
                ->createCommand('select count(dorsal) from ciclista where edad between 28 and 32 and nomequipo="Banesto"')
                ->queryScalar();
         
         $dataProvider=new SqlDataProvider([
            'sql'=>'select dorsal from ciclista where edad between 28 and 32 and nomequipo="Banesto"',
            'totalCount'=>$numero,
             'pagination'=>[
                'pageSize'=>5,
            ]
        
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 5 con DAO",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad este entre 28 y 32 y además que solo sean de Banesto",
            "sql"=>"select dorsal from ciclista where edad between 28 and 32 and nomequipo='Banesto'",
        ]);
        
        
    }
    
     public function actionConsulta5a() {
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("dorsal")
                ->distinct()
                ->where("edad between 28 and 32 and nomequipo='Banesto'"),
            'pagination'=>[
                'pageSize'=>5,
            ]
        ]);

        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=> "Consulta 5 con Active Record",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad este entre 28 y 32 y además que solo sean de Banesto",
            "sql"=>"select dorsal from ciclista where edad between 28 and 32 and nomequipo='Banesto'",
        ]);
        
        
    }
     public function actionConsulta6 () {
        // mediante DAO
         $name=Yii::$app
                ->db

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php
use yii\helpers\Html;

echo Html::a('Ciclistas', 
        ['ciclista/index'], 
        ['class' => 'col-md-3 col-md-offset-2 btn btn-primary btn-large']
        );

echo Html::a('Etapas', 
        ['etapa/index'], 
        ['class' => 'col-md-3 col-md-offset-2 btn btn-primary btn-large']
        );

echo Html::a('Puertos', 
        ['puerto/index'], 
        ['class' => 'col-md-3 col-md-offset-2 btn btn-primary btn-large']
        );

echo Html::a('Equipos', 
        ['equipo/index'], 
        ['class' => 'col-md-3 col-md-offset-2 btn btn-primary btn-large']
        );

echo Html::a('Maillots', 
        ['maillot/index'], 
        ['class' => 'col-md-3 col-md-offset-2 btn btn-primary btn-large']
        );

echo Html::a('Lleva', 
        ['lleva/index'], 
        ['class' => 'col-md-3 col-md-offset-2 btn btn-primary btn-large']
        );

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de Seleccion 1</h1>

        <p class="lead">Modulo 3 - Unidad 2</p>
    </div>

    <div class="body-content">
        <div class="row">
            <!-- 
            boton de consulta
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1</h3>
                        <p>Listar las edades de los ciclistas (sin repetidos)</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta1a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta1'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta
            -->
             <!--
            boton de consulta 2
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 2</h3>
                        <p>Listar las edades de los ciclistas de Artiach</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta2a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta2'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 2
            -->
              <!--
            boton de consulta 3
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 3</h3>
                        <p>Listar las edades de los ciclistas de Artiach o de Amore Vita</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 3
            -->
              <!--
            boton de consulta 4
            -->
            </div>
            <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 4</h3>
                        <p>Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 4
            -->
              <!--
            boton de consulta 5
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 5</h3>
                        <p>Listar los dorsales de los ciclistas cuya edad este entre 28 y 32 y además que solo sean de Banesto</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta5a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta5'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 5
            -->
               <!--
            boton de consulta 6
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 6</h3>
                        <p>Indicar el nombre de los ciclistas que el numero de caracteres del nombre sea mayor que 8</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta6a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta6'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 6
            -->
            </div>
            <div class="row">
               <!--
            boton de consulta 7
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 7</h3>
                        <p>Listar el nombre y el dorsal de todos los ciclistas mostrando un campo nuevo denominado nombre mayúsculas
                        que debe mostrar el nombre en mayúsculas</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta7a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta7'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 7
            -->
             <!--
            boton de consulta 8
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 8</h3>
                        <p>Listar todos los ciclistas que han llevado el maillot MGE(amarillo) en alguna etapa</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 8
            -->
            <!--
            boton de consulta 9
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 9</h3>
                        <p>Listar el nombre de los puertos cuya altura sea mayor que 1500</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta9a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta9'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 9
            -->
            </div>
            <div class="row">
             <!--
            boton de consulta 10
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 10</h3>
                        <p>Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 o cuya altura este entre 1800 y 3000</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta10a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta10'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 10
            -->
             <!--
            boton de consulta 11
            -->
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 11</h3>
                        <p>Listar el dorsal de los ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 y cuya altura este entre 1800 y 3000</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta11a'],['class' => 'btn btn-primary']); ?>
                            <?= Html::a('DAO',['site/consulta11'],['class' => 'btn btn-default']); ?>
                        </p>
                    </div>
                </div>
            </div>
            <!--
            fin de boton de consulta 11
            -->
        </div>
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

<div class="jumbotron">
        <h2><?= $titulo ?></h2>

        <p class="lead"><?= $enunciado ?></p>
        <div class="well"><?= $sql ?></div>

    </div>

    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
    ]); ?>